diff -Naur syslinux-2.08/conio.inc syslinux-2.08+newio/conio.inc
--- syslinux-2.08/conio.inc	2003-12-03 19:47:57.000000000 -0800
+++ syslinux-2.08+newio/conio.inc	2005-08-12 18:14:51.000000000 -0700
@@ -341,6 +341,7 @@
 .serial:	xor ah,ah		; Avoid confusion
 		xchg dx,bx		; Data port
 		in al,dx
+		mov byte [FromFlag],45	; '-' flags input from serial
 		ret
 .kbd:		xor ax,ax		; Get keyboard input
 		int 16h
@@ -348,6 +349,7 @@
 		jz .func_key
 		mov bx,KbdMap		; Convert character sets
 		xlatb
+		mov byte [FromFlag], 43 ; '+' flags input from console
 .func_key:	ret
 
 %ifdef DEBUG_TRACERS
diff -Naur syslinux-2.08/isolinux.asm syslinux-2.08+newio/isolinux.asm
--- syslinux-2.08/isolinux.asm	2003-12-03 19:47:57.000000000 -0800
+++ syslinux-2.08+newio/isolinux.asm	2005-08-12 18:05:30.000000000 -0700
@@ -1660,6 +1660,7 @@
 boot_image      db 'BOOT_IMAGE='
 boot_image_len  equ $-boot_image
                 align 4, db 0		; For the good of REP MOVSD
+FromFlag	db '?'			; where is input coming from?
 command_line	equ $
 default_cmd	equ $+(max_cmd_len+2)
 ldlinux_end	equ default_cmd+(max_cmd_len+1)
diff -Naur syslinux-2.08/ldlinux.asm syslinux-2.08+newio/ldlinux.asm
--- syslinux-2.08/ldlinux.asm	2003-12-03 19:47:57.000000000 -0800
+++ syslinux-2.08+newio/ldlinux.asm	2005-08-12 18:05:39.000000000 -0700
@@ -1459,6 +1459,7 @@
 boot_image      db 'BOOT_IMAGE='
 boot_image_len  equ $-boot_image
                 align 4, db 0		; For the good of REP MOVSD
+FromFlag	db '?'			; Where is the input coming from?
 command_line	equ $
 default_cmd	equ $+(max_cmd_len+2)
 ldlinux_end	equ default_cmd+(max_cmd_len+1)
diff -Naur syslinux-2.08/pxelinux.asm syslinux-2.08+newio/pxelinux.asm
--- syslinux-2.08/pxelinux.asm	2003-12-08 13:17:08.000000000 -0800
+++ syslinux-2.08+newio/pxelinux.asm	2005-08-12 18:05:47.000000000 -0700
@@ -2632,6 +2632,7 @@
 boot_image      db 'BOOT_IMAGE='
 boot_image_len  equ $-boot_image
                 align 4, db 0		; For the good of REP MOVSD
+FromFlag	db '?'			; where is input coming from?
 command_line	equ $
 default_cmd	equ $+(max_cmd_len+2)
 ldlinux_end	equ default_cmd+(max_cmd_len+1)
diff -Naur syslinux-2.08/ui.inc syslinux-2.08+newio/ui.inc
--- syslinux-2.08/ui.inc	2003-12-05 15:48:52.000000000 -0800
+++ syslinux-2.08+newio/ui.inc	2005-08-15 16:38:59.000000000 -0700
@@ -194,6 +194,13 @@
 ; First we need to mangle the kernel name the way DOS would...
 ;
 		mov si,command_line
+		call find
+		mov si,FromFlag
+		call find
+		mov si,command_line
+		jmp bad_kernel
+
+find:
                 mov di,KernelName
                 push si
                 push di
@@ -283,6 +290,8 @@
 		add bx,byte 4
 		cmp bx,exten_table_end
 		jna .search_loop		; allow == case (final case)
+		ret
+
 		; Fall into bad_kernel
 ;
 ; bad_kernel: Kernel image not found
--- syslinux-2.08/syslinux.doc	2003-12-05 13:55:41.000000000 -0800
+++ syslinux-2.08+newio/syslinux.doc	2005-08-15 17:01:49.000000000 -0700
@@ -182,6 +182,17 @@
 		The "kernel" doesn't have to be a Linux kernel; it can
 		be a boot sector or a COMBOOT file (see below.)
 
+		If the label is prefixed with a '+' or '-', it will be
+		loaded only if it is entered on the console (serial port);
+		this is an enhancement to allow a simple menu system
+		where the person installing the system can enter the
+		same command whether they're at the console or a serial
+		port and have it just work correctly. (Internally this is
+		a bit of a hack;  syslinux first seaches the labels against
+		what the user entered, and if that doesn't find anything
+		it prefexes the user input with '+' or '-' and searches
+		again.)
+
   APPEND -
         Append nothing.  APPEND with a single hyphen as argument in a
         LABEL section can be used to override a global APPEND.
